Libical API Documentation 3.0

Public Member Functions | Static Public Member Functions
LibICal::VComponent Class Reference

A class wrapping the libical icalcomponent functions. More...

`#include <vcomponent_cxx.h>`

Inheritance diagram for LibICal::VComponent:
[legend]

## Public Member Functions
| VComponent (const icalcomponent_kind &kind)
| VComponent (const std::string &str)
| VComponent (const VComponent &)
| VComponent (icalcomponent *v)
bool | add (VComponent &)
void | add_component (VComponent *child)
void | add_property (ICalProperty *property)
| Working with properties.
std::string | as_ical_string ()
icalcompiter | begin_component (const icalcomponent_kind &kind)
| Using external iterators.
void | convert_errors ()
| Convert some X-LIC-ERROR properties into RETURN-STATUS properties.
int | count_components (const icalcomponent_kind &kind)
int | count_errors ()
| Working with embedded error properties.
int | count_properties (const icalproperty_kind &kind)
VComponent * | current (icalcompiter *i)
void | detach ()
icalcompiter | end_component (const icalcomponent_kind &kind)
std::string | get_comment () const
VComponent * | get_current_component ()
| Iterate through components. More...
ICalProperty * | get_current_property ()
std::string | get_description () const
struct icaltimetype | get_dtend () const
struct icaltimetype | get_dtstamp () const
struct icaltimetype | get_dtstart () const
struct icaltimetype | get_due () const
struct icaldurationtype | get_duration () const
VComponent * | get_first_component (const icalcomponent_kind &kind)
ICalProperty * | get_first_property (const icalproperty_kind &kind)
VComponent * | get_first_real_component ()
VComponent * | get_inner ()
std::string | get_location () const
icalproperty_method | get_method () const
VComponent * | get_next_component (const icalcomponent_kind &kind)
ICalProperty * | get_next_property (const icalproperty_kind &kind)
struct icaltimetype | get_recurrenceid () const
std::string | get_relcalid () const
int | get_sequence () const
virtual struct icaltime_span | get_span ()
int | get_status () const
std::string | get_summary () const
std::string | get_uid () const
bool | is_valid ()
icalcomponent_kind | isa ()
int | isa_component (void *component)
void | new_from_string (const std::string &str)
VComponent * | next (icalcompiter *i)
| operator icalcomponent * ()
VComponent & | operator= (const VComponent &)
VComponent * | prev (icalcompiter *i)
int | recurrence_is_excluded (struct icaltimetype *dtstart, struct icaltimetype *recurtime)
bool | remove (VComponent &, bool ignoreValue)
| Note: the VComponent kind have to be the same.
void | remove_component (VComponent *child)
void | remove_property (ICalProperty *property)
void | set_comment (const std::string &v)
void | set_description (const std::string &v)
void | set_dtend (const struct icaltimetype &v)
void | set_dtstamp (const struct icaltimetype &v)
void | set_dtstart (const struct icaltimetype &v)
void | set_due (const struct icaltimetype &v)
void | set_duration (const struct icaldurationtype &v)
void | set_location (const std::string &v)
void | set_method (const icalproperty_method &method)
void | set_recurrenceid (const struct icaltimetype &v)
void | set_relcalid (const std::string &v)
void | set_sequence (const int &v)
void | set_status (const enum icalproperty_status &v)
void | set_summary (const std::string &v)
void | set_uid (const std::string &v)
void | strip_errors ()
| Remove all X-LIC-ERROR properties.
bool | update (VComponent &, bool removeMissing)

## Static Public Member Functions
static std::string | kind_to_string (const icalcomponent_kind &kind)
static icalcomponent_kind | string_to_kind (const std::string &str)
| Kind conversion routines.

## Detailed Description

A class wrapping the libical icalcomponent functions.

Exceptions

  icalerrorenum | Any errors generated in libical are propagated via this exception type.

## Member Function Documentation

## ◆ get_current_component()

VComponent * LibICal::VComponent::get_current_component | ( |  | ) |

Iterate through components.

Iteration Routines. There are two forms of iterators, internal and external. The internal ones came first, and are almost completely sufficient, but they fail badly when you want to construct a loop that removes components from the container.

## ◆ get_dtend()

struct icaltimetype LibICal::VComponent::get_dtend | ( |  | ) | const

For the icalcomponent routines only, dtend and duration are tied together. If you call the set routine for one and the other exists, the routine will calculate the change to the other. That is, if there is a DTEND and you call set_duration, the routine will modify DTEND to be the sum of DTSTART and the duration. If you call a get routine for one and the other exists, the routine will calculate the return value. If you call a set routine and neither exists, the routine will create the appropriate property

## ◆ get_first_real_component()

VComponent * LibICal::VComponent::get_first_real_component | ( |  | ) |

For VCOMPONENT: Return a reference to the first VEVENT, VTODO, or VJOURNAL

## ◆ get_inner()

VComponent * LibICal::VComponent::get_inner | ( |  | ) |

Return the first VEVENT, VTODO or VJOURNAL sub-component if it is one of those types

## ◆ get_span()

virtual struct icaltime_span LibICal::VComponent::get_span | ( |  | ) |
| virtual

For VEVENT, VTODO, VJOURNAL and VTIMEZONE: report the start and end times of an event in UTC

The documentation for this class was generated from the following file:

- vcomponent_cxx.h